"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var React = require("react");
var antd_1 = require("antd");
var player_1 = require("../../player");
require("./style.css");
var MAudio = function (props, ref) {
    var info = props.info, src = props.src, poster = props.poster, autoplay = props.autoplay, onChange = props.onChange, onOperate = props.onOperate;
    var _a = react_1.useState(false), playing = _a[0], setPlaying = _a[1];
    var _b = react_1.useState(), music = _b[0], setMusic = _b[1];
    var musicRef = react_1.createRef();
    var refs = {
        musicAvatar: react_1.useRef(),
        progress: react_1.useRef(),
        buffered: react_1.useRef(),
        played: react_1.useRef(),
        totalTime: react_1.useRef(),
        remainTime: react_1.useRef(),
        totalVolume: react_1.useRef(),
        volumeProgress: react_1.useRef()
    };
    // 开放Api
    react_1.useImperativeHandle(ref, function () { return ({
        onPlay: function (id) {
            musicRef.current.playMusic(id);
        }
    }); });
    react_1.useEffect(function () {
        setMusic(info[0]);
    }, []);
    var handleMusic = function (method, time) {
        musicRef.current[method](time);
    };
    var onMusicEvents = function (e, method) {
        musicRef.current[method](e);
    };
    var hanleChange = function (value) {
        setMusic(value);
        if (onChange && typeof onChange === 'function') {
            onChange(value);
        }
    };
    var hanleOption = function (value) {
        if (onOperate && typeof onOperate === 'function') {
            onOperate(value);
        }
    };
    console.log(playing);
    return (React.createElement(player_1.default, { info: info, ref: musicRef, refs: refs, autoplay: autoplay, onPlaying: function (value) { return setPlaying(value); }, onChange: function (value) { return hanleChange(value); }, onOperate: function (value) { return hanleOption(value); }, onError: function (error) { return antd_1.message.error(error); } },
        React.createElement("div", { className: 'audioPanel' },
            React.createElement("div", { className: 'control' },
                React.createElement("img", { className: 'icon_btn', src: './images/ic_prev_time.png', onClick: function () { return handleMusic('fastForward', -15); } }),
                React.createElement("img", { className: 'icon_btn', src: './images/ic_prev.png', onClick: function () { return handleMusic('last'); } }),
                React.createElement("div", null,
                    React.createElement("img", { className: 'play', src: !playing ? './images/ic_play.png' : './images/ic_pause.png', onClick: function () { return handleMusic('play'); } })),
                React.createElement("img", { className: 'icon_btn', src: './images/ic_next.png', onClick: function () { return handleMusic('next'); } }),
                React.createElement("img", { className: 'icon_btn', src: './images/ic_next_time.png', onClick: function () { return handleMusic('fastForward', 15); } })),
            React.createElement("div", { className: 'audiobar' },
                React.createElement("img", { className: 'icon_play', src: !playing ? './images/icon_play.png' : './images/icon_pause.png', onClick: function () { return handleMusic('play'); } }),
                React.createElement("div", { className: 'startime', ref: refs.remainTime }, "00:00"),
                React.createElement("div", { className: 'progress-wrapper', ref: refs.progress, onTouchMove: function (e) { return onMusicEvents(e, 'changeTime'); }, onTouchStart: function (e) { return onMusicEvents(e, 'changeTime'); }, onClick: function (e) { return onMusicEvents(e, 'changeTime'); }, onMouseDown: function (e) { return onMusicEvents(e, 'mouseDown'); }, onMouseMove: function (e) { return onMusicEvents(e, 'slideTime'); }, onMouseUp: function (e) { return onMusicEvents(e, 'mouseLeave'); }, onMouseLeave: function (e) { return onMusicEvents(e, 'mouseLeave'); } },
                    React.createElement("div", { className: 'progress' },
                        React.createElement("div", { className: 'progress-buffered', ref: refs.buffered }),
                        React.createElement("div", { className: 'progress-played', ref: refs.played }))),
                React.createElement("div", { className: 'endtime', ref: refs.totalTime }, "00:00"),
                React.createElement("div", { className: 'volume-control', ref: refs.totalVolume },
                    React.createElement("div", { className: 'volume-progress', ref: refs.volumeProgress }))))));
};
exports.default = react_1.forwardRef(MAudio);
