"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_1 = require("react");
var antd_1 = require("antd");
var player_1 = require("../../player");
require("./style.css");
var WebAudio = function (props, ref) {
    var info = props.info, autoplay = props.autoplay, onChange = props.onChange, onOperate = props.onOperate, currentTime = props.currentTime, onTimeUpdate = props.onTimeUpdate, onPlay = props.onPlay;
    var _a = react_1.useState(false), playing = _a[0], setPlaying = _a[1];
    var _b = react_1.useState(), music = _b[0], setMusic = _b[1];
    var musicRef = react_1.createRef();
    var refs = {
        musicAvatar: react_1.useRef(),
        progress: react_1.useRef(),
        buffered: react_1.useRef(),
        played: react_1.useRef(),
        totalTime: react_1.useRef(),
        remainTime: react_1.useRef(),
        totalVolume: react_1.useRef(),
        volumeProgress: react_1.useRef()
    };
    // 开放Api
    react_1.useImperativeHandle(ref, function () { return ({
        onPlay: function () {
            musicRef.current.play();
        },
        onTime: function () {
            return musicRef.current.onTime();
        },
        isPlay: function () {
            return musicRef.current.isPlay();
        }
    }); });
    react_1.useEffect(function () {
        setMusic(info[0]);
    }, []);
    var handleMusic = function (method) {
        musicRef.current[method]();
    };
    var onMusicEvents = function (e, method) {
        musicRef.current[method](e);
    };
    var hanleChange = function (value) {
        setMusic(value);
        if (onChange && typeof onChange === 'function') {
            onChange(value);
        }
    };
    var hanleOption = function (value) {
        if (onOperate && typeof onOperate === 'function') {
            onOperate(value);
        }
    };
    var hanlePlay = function (value) {
        setPlaying(value);
        if (onPlay && typeof onPlay === 'function') {
            onPlay(value);
        }
    };
    var hanleTimeUpdate = function (currentTime, duration) {
        if (onTimeUpdate && typeof onTimeUpdate === 'function') {
            onTimeUpdate(currentTime, duration);
        }
    };
    return (React.createElement(player_1.default, { refs: refs, ref: musicRef, info: info, autoplay: autoplay, curTime: currentTime, onPlaying: function (value) { return hanlePlay(value); }, onChange: function (value) { return hanleChange(value); }, onOperate: function (value) { return hanleOption(value); }, onError: function (error) { return antd_1.message.error(error); }, onTimeUpdate: function (currentTime, duration) { return hanleTimeUpdate(currentTime, duration); } },
        React.createElement("div", { className: 'player' },
            React.createElement("div", { className: 'music-player' },
                React.createElement("div", { className: 'music-box' },
                    React.createElement("div", { className: 'picture' },
                        React.createElement("img", { src: music && music.img, ref: refs.musicAvatar, alt: "\u56FE\u7247\u4E22\u5931\u4E86" })),
                    React.createElement("div", { className: 'bar' },
                        React.createElement("div", { className: !playing ? 'demand-off' : 'demand-on' })))),
            React.createElement("div", { className: 'music-control' },
                React.createElement("div", { className: 'music-info' },
                    React.createElement("div", { className: 'time' },
                        React.createElement("span", { className: 'remain-time', ref: refs.remainTime }, "00:00"),
                        React.createElement("span", null, "/"),
                        React.createElement("span", { className: 'total-time', ref: refs.totalTime }, "00:00")),
                    React.createElement("div", { className: 'music-name' }),
                    React.createElement("div", { className: 'progress-wrapper', ref: refs.progress, onTouchMove: function (e) { return onMusicEvents(e, 'changeTime'); }, onTouchStart: function (e) { return onMusicEvents(e, 'changeTime'); }, onClick: function (e) { return onMusicEvents(e, 'changeTime'); }, onMouseDown: function (e) { return onMusicEvents(e, 'mouseDown'); }, onMouseMove: function (e) { return onMusicEvents(e, 'slideTime'); }, onMouseUp: function (e) { return onMusicEvents(e, 'mouseLeave'); }, onMouseLeave: function (e) { return onMusicEvents(e, 'mouseLeave'); } },
                        React.createElement("div", { className: 'progress' },
                            React.createElement("div", { className: 'progress-buffered', ref: refs.buffered }),
                            React.createElement("div", { className: 'progress-played', ref: refs.played })))),
                React.createElement("div", { className: 'control' },
                    React.createElement("div", { className: 'left-control' },
                        React.createElement(antd_1.Icon, { type: "step-backward", className: 'icon-last', onClick: function () { return handleMusic('last'); } }),
                        React.createElement("span", { className: playing ? "icon-pause" : "icon-play", onClick: function () { return handleMusic('play'); } }),
                        React.createElement(antd_1.Icon, { type: "step-forward", className: 'icon-last', onClick: function () { return handleMusic('next'); } })),
                    React.createElement("div", { className: 'right-control' },
                        React.createElement("div", { className: 'volume-control-wrapper', onTouchMove: function (e) { return onMusicEvents(e, 'changeVolume'); }, onTouchStart: function (e) { return onMusicEvents(e, 'changeVolume'); }, onClick: function (e) { return onMusicEvents(e, 'changeVolume'); }, onMouseDown: function (e) { return onMusicEvents(e, 'mouseDown'); }, onMouseMove: function (e) { return onMusicEvents(e, 'slideVolume'); }, onMouseUp: function (e) { return onMusicEvents(e, 'mouseLeave'); }, onMouseLeave: function (e) { return onMusicEvents(e, 'mouseLeave'); } },
                            React.createElement("div", { className: 'volume-control', ref: refs.totalVolume },
                                React.createElement("div", { className: 'volume-progress', ref: refs.volumeProgress }))),
                        React.createElement("span", { className: 'icon-volume' })))))));
};
exports.default = react_1.forwardRef(WebAudio);
